proc/isRoad(ground)	// This proc will see if turf a is a road turf
	if(istype(ground,/turf/road))
		return 1	// If it is, return 1
	else
		return 0

mob/car/proc

	Check()	//This proc is used to verify that at all times the car is on a road
		if(!isRoad(loc))
			return "NOTROAD"	// If not a road, return "NROAD"
		else return "OK"		// If it is, return "OK"

	N() // When car direction is NORTH. Determines next move
		var/myMove = NORTH // Returned variable. It defaults to the car's direction, NORTH

		// The following variables return a location in relation to the car according to
		// the arguments passed to the locate proc. (e.g. x is the x-coordinate, x-1 is one
		// step WEST). The actual returned value is 1 or 0, 1 if it is a road.
		var/n	=	isRoad( locate(x,y+1,z)	 )
		var/nn	=	isRoad( locate(x,y+2,z)	 )
		var/e	=	isRoad( locate(x+1,y,z)	 )
		var/ne	=	isRoad( locate(x+1,y+1,z) )
		var/w	=	isRoad( locate(x-1,y,z)	 )
		var/ww	=	isRoad( locate(x-2,y,z)	 )
		var/nw	=	isRoad( locate(x-1,y+1,z) )
		var/nww	=	isRoad( locate(x-2,y+1,z) )
		var/sw	=	isRoad( locate(x-1,y-1,z) )
		var/sww =	isRoad( locate(x-2,y-1,z) )

		if(n) // If n is not null and n is a road
			if(nn) // If nn is not null and nn is a road
				if(e && ne) // I'm going to stop pointing out the obvious
					if(w && ww && sw && sww)
						myMove = pick(NORTH,EAST,WEST)
					else // If w, ww, sw, and sww are not all roads but e and ne are
						myMove = pick(NORTH,EAST)
				else if(w && ww && sw && sww) // If e and ne arent roads but w, ww, etc are...
					myMove = pick(NORTH,WEST)
				else // If neither (e and ne) nor (w, ww, sw, and sww) are roads...
					myMove = NORTH
			else if(e && ne) // If nn is not a road but e and ne are(you need a visual mind)...
				if(w && ww && nw && nww) // This checks if left-turn is available
					myMove = pick(NORTH,EAST)
					// Why NORTH? nn wasn't a road? Keep in mind that in order for a car to
					// make a left turn and stay in the right lane, it must move forward to the
					// end of the road and turn
				else if(w&&ww&&sw&&sww)
					myMove = pick(EAST,WEST)
				else // If the WEST lane is unavailable but the EAST lane is...
					myMove = EAST
			else if(w && ww && nw && nww) // If EAST lane is not there but the WEST one is...
				myMove = NORTH // Go to the end for the turn
			else if(w && ww && sw && sww) // Or if it's already there...
				myMove = WEST
		else if(w && ww && sw && sww) //If there no road to the NORTH, but there is to the WEST..
			myMove = WEST
		return myMove // Return myMove to the Drive proc
	S() // I'm not goin over the rest of these, they're on the same principle as the one above
		var/myMove = SOUTH

		var/s	=	isRoad( locate(x,y-1,z)	)
		var/ss	=	isRoad( locate(x,y-2,z)	)
		var/w	=	isRoad( locate(x-1,y,z)	)
		var/sw	=	isRoad( locate(x-1,y-1,z))
		var/e	=	isRoad( locate(x+1,y,z)	)
		var/ee	=	isRoad( locate(x+2,y,z)	)
		var/se	=	isRoad( locate(x+1,y-1,z))
		var/see	=	isRoad( locate(x+2,y-1,z))
		var/ne	=	isRoad( locate(x+1,y+1,z))
		var/nee =	isRoad( locate(x+2,y+1,z))

		if(s)
			if(ss)
				if(w && sw)
					if(e && ee && ne && nee)
						myMove = pick(SOUTH,WEST,EAST)
					else
						myMove = pick(SOUTH,WEST)
				else if(e && ee && ne && nee)
					myMove = pick(SOUTH,EAST)
			else if(w && sw)
				if(e && ee && se && see)
					myMove = pick(SOUTH,WEST)
				else if(e && ee && ne && nee)
					myMove = pick(WEST,EAST)
				else
					myMove = WEST
			else if(e && ee && se && see)
				myMove = SOUTH
			else if(e && ee && ne && nee)
				myMove = EAST
			else
				myMove = SOUTH
		else if(e && ee && ne && nee)
			myMove = EAST
		return myMove
	E()
		var/myMove = EAST

		var/e	=	isRoad( locate(x+1,y,z)	)
		var/ee	=	isRoad( locate(x+2,y,z)	)
		var/s	=	isRoad( locate(x,y-1,z)	)
		var/se	=	isRoad( locate(x+1,y-1,z))
		var/n	=	isRoad( locate(x,y+1,z)	)
		var/nn	=	isRoad( locate(x,y+2,z)	)
		var/ne	=	isRoad( locate(x+1,y+1,z))
		var/nne	=	isRoad( locate(x+1,y+2,z))
		var/nw	=	isRoad( locate(x-1,y+1,z))
		var/nnw	=	isRoad( locate(x-1,y+2,z))

		if(e)
			if(ee)
				if(s && se)
					if(n && nn && nw && nnw)
						myMove = pick(EAST,SOUTH,NORTH)
					else
						myMove = pick(EAST,SOUTH)
				else if(n && nn && nw && nnw)
					myMove = pick(EAST,NORTH)
				else
					myMove = EAST
			else if(s && se)
				if(n && nn && ne && nne)
					myMove = pick(EAST,SOUTH)
				else if(n && nn && nw && nnw)
					myMove = pick(SOUTH,NORTH)
				else
					myMove = SOUTH
			else if(n && nn && ne && nne)
				myMove = EAST
			else if(n && nn && nw && nnw)
				myMove = NORTH
			else
				myMove = EAST
		else if(n && nn && nw && nnw)
			myMove = NORTH
		return myMove
	W()
		var/myMove = WEST

		var/w	=	isRoad( locate(x-1,y,z)	)
		var/ww	=	isRoad( locate(x-2,y,z)	)
		var/n	=	isRoad( locate(x,y+1,z)	)
		var/nw	=	isRoad( locate(x-1,y+1,z))
		var/s	=	isRoad( locate(x,y-1,z)	)
		var/ss	=	isRoad( locate(x,y-2,z)	)
		var/sw	=	isRoad( locate(x-1,y-1,z))
		var/ssw	=	isRoad( locate(x-1,y-2,z))
		var/se	=	isRoad( locate(x+1,y-1,z))
		var/sse	=	isRoad( locate(x+1,y-2,z))

		if(w)
			if(ww)
				if(n && nw)
					if(s && ss && se && sse)
						myMove = pick(WEST,NORTH,SOUTH)
					else
						myMove = pick(WEST,NORTH)
				else if(s && ss && se && sse)
					myMove = pick(WEST,SOUTH)
				else
					myMove = WEST
			else if(n && nw)
				if(s && ss && sw && ssw)
					myMove = pick(WEST,NORTH)
				else if(s && ss && se && sse)
					myMove = pick(NORTH,SOUTH)
				else
					myMove = NORTH
			else if(s && ss && sw && ssw)
				myMove = WEST
			else if(s && ss && se && sse)
				myMove = SOUTH
			else
				myMove = WEST
		else if(s && ss && se && sse)
			myMove = SOUTH
		return myMove

	CarDir() // This determines a car's next step
		set background = 1
		var/myDirection = dir // var myDirection equals the car's direction
		switch(dir)
			if(NORTH)
				myDirection = N()
			if(SOUTH)
				myDirection = S()
			if(EAST)
				myDirection = E()
			if(WEST)
				myDirection = W()
		return myDirection // The value of variable myDirection is returned to the Drive proc

	Drive()		// This is the main proc---it moves the cars
		set background=1
		var/continueLoop = 1
		while(continueLoop)
			var/onRoad=Check()
			if(onRoad=="NOTROAD")
				del(src)

			var/myDirection = CarDir()

			// Detect stop lights and stop signs:
			switch(dir)
				if(NORTH)
					for(var/obj/stop/light/Stop in get_step(src,EAST))
						if(Stop.icon_state=="r" && Stop.dir==SOUTH)
							while(Stop.icon_state=="r")
								sleep(3)
					for(var/obj/stop/sign/Stop in get_step(src,EAST))
						if(Stop.dir==SOUTH)
							sleep(3)
				if(SOUTH)
					for(var/obj/stop/light/Stop in get_step(src,WEST))
						if(Stop.icon_state=="r" && Stop.dir==NORTH)
							while(Stop.icon_state=="r")
								sleep(3)
					for(var/obj/stop/sign/Stop in get_step(src,WEST))
						if(Stop.dir==NORTH)
							sleep(3)
				if(EAST)
					for(var/obj/stop/light/Stop in get_step(src,SOUTH))
						if(Stop.icon_state=="r" && Stop.dir==WEST)
							while(Stop.icon_state=="r")
								sleep(3)
					for(var/obj/stop/sign/Stop in get_step(src,SOUTH))
						if(Stop.dir==WEST)
							sleep(3)
				if(WEST)
					for(var/obj/stop/light/Stop in get_step(src,NORTH))
						if(Stop.icon_state=="r" && Stop.dir==EAST)
							while(Stop.icon_state=="r")
								sleep(3)
					for(var/obj/stop/sign/Stop in get_step(src,NORTH))
						if(Stop.dir==EAST)
							sleep(3)

			// Car-Bump prevention  This prevents cars from bumping and calling the bump proc
			var/nextLoc = get_step(src,myDirection)
			var/mob/car/otherCar
			for(otherCar in nextLoc) // and if there are any cars in front...
				sleep(3)
				break
			//End of Car-Bump prevention

			///*
			//U-turn prevention!  To prevent ugly u-turns at intersections
			switch(myDirection)

				if(NORTH)
					if(dir==EAST) // If it is facing east(going north makes a left turn)...
						step(src,myDirection) // Add an extra step(requires some thought)
						sleep(3) //And give it the same pause regularly passed

				if(SOUTH)
					if(dir==WEST)
						step(src,myDirection)
						sleep(3)

				if(EAST)
					if(dir==SOUTH)
						step(src,myDirection)
						sleep(3)

				if(WEST)
					if(dir==NORTH)
						step(src,myDirection)
						sleep(3)
			//End of U-turn prevention
			//*/
// To see why I'm stopping most U-turns, remove the //'s from the
// /* and */. Then watch the cars drive. It's UGLY.
			step(src,myDirection) // If it's got through all that, take the step.
			sleep(3)
		sleep(2)	// When break is called, sleep for 2/10 seconds...
		Drive()		// ...and call Drive again